/***************************************************************************
 *   Copyright (C) 2009 by Guy Rutenberg <guyrutenberg@gmail.com>	   *
 *                                                                         *
 *   This is free software; you can redistribute it and/or modify          *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef BASIC_AI_ENGINE_INC
#define BASIC_AI_ENGINE_INC

#include "abstract_ai_engine.h"

class BasicAiEngine : public AbstractAiEngine
{
	int scoring_house[2];
	int house_[12];
	int last_move;
	int next_player;
	int search_depth;
	bool isValidMove(int i);
	void makeUnvalidatedMove(int i);
	
	int alphaBetaPrune(int depth, int alpha, int beta, int &heuristic_value);
	int heuristicEvaluation();
public:
	BasicAiEngine(int search_depth);
	//~BasicAiEngine(){};

	virtual int scoringHouse(int i);
	virtual int house(int i);
	virtual int lastMove();
	virtual bool makeMove(int i);
	virtual int makeAiMove();
	virtual int nextPlayer();
	virtual bool isGameOver();
};

#endif // BASIC_AI_ENGINE_INC
