/***************************************************************************
 *   Copyright (C) 2009 by Guy Rutenberg <guyrutenberg@gmail.com>	   *
 *                                                                         *
 *   This is free software; you can redistribute it and/or modify          *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "ai/abstract_ai_engine.h"
#include "ai/basic_ai_engine.h"

#include <iostream>

using namespace std;

ostream &operator<<(ostream &stream, AbstractAiEngine *ai_engine)
{
	for (int i = 11; i > 5; i--) {
		stream << "\t" << ai_engine->house(i);
	}
	stream << "\n" << ai_engine->scoringHouse(1) << "\t\t\t\t\t\t\t" << ai_engine->scoringHouse(0) << "\n";
	for (int i = 0; i < 6; i++) {
		stream << "\t" << ai_engine->house(i);
	}
	stream << "\n";
}
int main(int argc, char **argv)
{
	int level;
	cout << "Enter difficulty: 1.. : ";
	cin >> level;
	AbstractAiEngine *ai_engine = new BasicAiEngine(level);

	bool computer_turn = 0;
	int move;
	int computer_heuristic;
	while (!ai_engine->isGameOver()) {
		cout << ai_engine << endl;
		if (computer_turn) {
			computer_heuristic = ai_engine->makeAiMove();
			cout << "Computer sowed from house: " << ai_engine->lastMove();
			cout << " (" << computer_heuristic << ")"<<endl;
		} else {
			cout << "Enter your move (0..5): ";
			cin >> move;
			while (! ai_engine->makeMove(move)) {
				cout << "The move you entered was invalid. Enter your move (0..5): ";
				cin >> move;
			}
		}
		computer_turn =! computer_turn;
	}

	cout << "GAME OVER!!"<<endl<<endl;
	cout << ai_engine << endl;

	delete ai_engine;
	return 0;
}
